unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, SzogPont, Grids, CheckLst, grafp;

type
  Tmained = class(TForm)
    grafok: TStringGrid;
    exitbutt: TButton;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure exitbuttClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  mained: Tmained;

implementation

uses ugraf, Unit2, Unit3;

{$R *.dfm}

procedure Tmained.FormCreate(Sender: TObject);
var f:textfile; n,i:integer; name,fl:string[20]; szpsz,irany,suly,elsz:integer;
begin
  grafok.rows[0].Add('Name');
  grafok.rows[0].Add('File');
  grafok.rows[0].Add('Number of nodes');
  grafok.rows[0].Add('Number of edges');
  grafok.rows[0].Add('Directed?');
  grafok.rows[0].Add('Weighted?');
  assignfile(f,'graphs.txt');
  reset(f);
  readln(f,n);
  for i:=1 to n do begin
      readln(f,name);
      readln(f,fl);
      readln(f,szpsz);
      readln(f,elsz);
      readln(f,irany);
      readln(f,suly);
      with grafok.rows[grafok.RowCount-1] do begin
        strings[0]:=name;
        strings[1]:=fl;
        strings[2]:=inttostr(szpsz);
        strings[3]:=inttostr(elsz);
        if irany=1 then strings[4]:='Directed' else strings[4]:='Undirected';
        if suly=1 then strings[5]:='Weighted' else strings[5]:='Unweighted';

      end;
      grafok.RowCount:=1+grafok.RowCount;
  end;
  grafok.RowCount:=grafok.RowCount-1;
  closefile(f)

end;

procedure Tmained.exitbuttClick(Sender: TObject);
begin
  application.Terminate;
end;

procedure Tmained.Button1Click(Sender: TObject);
var i:integer;
begin
form2.callst.Clear;
form2.dispg.LoadFromFile(grafok.Rows[grafok.Selection.Top].Strings[1]);
form2.lattam.colcount:=form2.dispg.graff.szogpontszam;
for i:=1 to form2.dispg.graff.szogpontszam do begin
  form2.lattam.cells[i-1,0]:=inttostr(i);
  form2.lattam.cells[i-1,1]:='F'
end;

form2.matr.LoadFromGraf(form2.dispg.graff);
  form2.ShowModal;
end;

procedure Tmained.Button2Click(Sender: TObject);
var i:integer;
begin
szel.dispg.LoadFromFile(grafok.Rows[grafok.Selection.Top].Strings[1]);
szel.lattam.colcount:=szel.dispg.graff.szogpontszam;
for i:=1 to szel.dispg.graff.szogpontszam do begin
  szel.lattam.cells[i-1,0]:=inttostr(i);
  szel.lattam.cells[i-1,1]:='F'
end;
szel.fiffo.ColCount:=szel.dispg.graff.szogpontszam;
for i:=1 to szel.dispg.graff.szogpontszam do begin
   szel.fiffo.Cells[i-1,0]:=inttostr(i);
   szel.fiffo.Cells[i-1,1]:='';
   szel.fiffo.Cells[i-1,2]:='';
end;


szel.matr.LoadFromGraf(szel.dispg.graff);
  szel.ShowModal;
end;

end.

