unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls,ugraf, ExtCtrls, SzogPont;

type
  Tedit = class(TForm)
    Splitter1: TSplitter;
    Panel1: TPanel;
    matr: TStringGrid;
    Panel2: TPanel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Button3: TButton;
    Button1: TButton;
    Button2: TButton;
    Button6: TButton;
    Button4: TButton;
    Button5: TButton;
    GroupBox4: TGroupBox;
    sg: TCheckBox;
    procedure matrSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure nyilline(x1,y1,x2,y2,d:integer; sz:real);
    procedure FormPaint(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SzogPont1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SzogPont1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SzogPont1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure doconnect(a,b:integer);
    procedure rp;
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  flnm:string;
  edit: Tedit;
  graff:Tgraf; isnew,iss:boolean;
  spk:array[1..100] of Tszogpont;
  spkn:integer; a0a,a1a:integer;
implementation

uses Unit1, Unit4;

{$R *.dfm}

procedure Tedit.matrSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
    if value='' then exit;
    if strtointdef(value,-1)=-1 then showmessage('invalid data');
    graff.adatok[arow,acol]:=strtointdef(value,-1);
    if not graff.iranyitott then begin
    graff.adatok[acol,arow]:=strtointdef(value,-1);
    matr.Cells[arow,acol]:=value
    end;
    edit.Repaint;
end;

procedure Tedit.nyilline(x1,y1,x2,y2,d:integer; sz:real);
function mpipi(p:real):real;
begin
      while p>=pi do p:=p-2*pi;
      while p<-pi do P:=p+2*pi;
      mpipi:=p
end;
procedure newline(x0,y0,d:integer;alf:real);
var x,y:real;
begin
     alf:=mpipi(alf);
     if alf=pi/2 then begin x:=0; y:=d end else
     if alf=-pi/2 then begin x:=0; y:=-d end else begin
        if (alf=pi/2)or(alf=-pi/2) then x:=0;
        x:=d/sqrt((sin(alf)*sin(alf))/(cos(alf)*cos(alf)) + 1);
        if (alf>pi/2) or (alf<-pi/2) then x:=-x;
        y:=x*sin(alf)/cos(alf)
     end;
     with canvas do begin
          moveto(x0,y0);
          lineto(trunc(x)+x0,trunc(y)+y0);
     end;
end;

var beta:real;
begin
    if graff.iranyitott then begin
     if x2=x1 then begin beta:=pi/2;
     if y2<y1 then beta:=-beta; end else begin
     beta:=arctan((y2-y1)/(x2-x1));
     IF X2-X1<0 then beta:=beta+pi; end;
     newline((x1+x2) div 2,(y1+y2) div 2,d,beta+pi-sz);
     newline((x1+x2) div 2,(y1+y2) div 2,d,beta+pi+sz);
    end;
     with canvas do begin moveto(x1,y1); lineto(x2,y2); end;
end;
procedure Tedit.FormPaint(Sender: TObject);
begin
  rp;
end;

procedure Tedit.Button1Click(Sender: TObject);
var gsz,i:integer;
begin
     graff.szogpontszam:=graff.szogpontszam+1; gsz:=graff.szogpontszam;
     matr.RowCount:=gsz+1;
     matr.ColCount:=gsz+1;
     matr.Cells[gsz,0]:=inttostr(gsz);
     matr.Cells[0,gsz]:=inttostr(gsz);
     for i:=1 to gsz do begin
         matr.Cells[gsz,i]:='0';
         matr.Cells[i,gsz]:='0';
         graff.adatok[gsz,i]:=0;
         graff.adatok[i,gsz]:=0;
     end;
     inc(spkn); i:=spkn;
     spk[i]:=Tszogpont.Create(edit);
      with spk[i] do begin
           Parent:=edit;
           Caption:=inttostr(i);
           Height:=19;
           Width:=19;
           Left:=0;
           Top:=0;
           index:=i;
           {Visible:=false; }
           OnMouseDown:=edit.SzogPont1MouseDown;
           OnMouseUp:=edit.SzogPont1Mouseup;
           OnMouseMove:=edit.SzogPont1MouseMove
      end;
      isnew:=true;
end;

procedure Tedit.SzogPont1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if isnew then with graff do with Tszogpont(Sender) do begin
      koord[index,1]:=cx;
      koord[index,2]:=cy
   end;
   isnew:=false;
   Tszogpont(Sender).isdown:=true; a0a:=Tszogpont(Sender).index; iss:=false;
   Tszogpont(Sender).smx:=x; Tszogpont(Sender).smy:=y;
end;

procedure Tedit.SzogPont1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
Tszogpont(Sender).isdown:=false;
end;

procedure Tedit.SzogPont1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var i:integer;
begin
with Tszogpont(Sender) do begin
  if isdown then begin
  visible:=true;
  //if (left+x-smx<=0) or (top+y-smy<=0) then begin exit end;
  if left+x-smx>=0 then left:=left+x-smx; if top+y-smy>=0 then top:=top+y-smy;
  canvas.Pen.Color:=$00F4DAC1;
  canvas.Font.Color:=$00F4DAC1;
  for i:=1 to graff.szogpontszam do begin doconnect(i,index); doconnect(index,i) end;
  graff.koord[index,1]:=cx;
  graff.koord[index,2]:=cy;
  canvas.Pen.Color:=clblack;
  canvas.Font.Color:=$00400080;
  rp;//for i:=1 to graff.szogpontszam do begin doconnect(i,index); doconnect(index,i) end;
 // edit.Repaint;
 for i:=1 to spkn do spk[i].rePaint;
end else formmousemove(Sender,Shift,x+left,y+top);
end;
end;

procedure Tedit.Button4Click(Sender: TObject);
var i,j,sum:integer;
begin
     graff.savetofile(flnm);
     with mained do
      with grafok.rows[grafok.Selection.Top] do begin
         Strings[2]:=inttostr(graff.szogpontszam);
         sum:=0;
         for i:=1 to graff.szogpontszam do
           for j:=1 to graff.szogpontszam do if graff.adatok[i,j]<>0 then sum:=sum+1;
         if not graff.iranyitott then sum:=sum div 2;
         Strings[3]:=inttostr(sum);
      end;
     modalresult:=mrok;
end;

procedure Tedit.FormShow(Sender: TObject);
begin
     isnew:=false;
     canvas.Font.Color:=$00400080;
end;

procedure Tedit.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if isnew then begin
         spk[spkn].CX:=x;
         spk[spkn].Cy:=y;

   end;
end;

procedure Tedit.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
isnew:=false;
end;
procedure Tedit.doconnect(a,b:integer);
var     cx,cy:integer;
begin
  with graff do if adatok[a,b]<>0 then begin
    nyilline(koord[a,1],koord[a,2],koord[b,1],koord[b,2],15,pi/6);
    if graff.sulyozott then with canvas do begin
         cx:=(koord[a,1]+koord[b,1]) div 2; cy:=(koord[a,2]+koord[b,2])div 2;
         if (iranyitott) and(a>b) then cy:=cy-textheight(inttostr(graff.adatok[a,b]))+2;
         Textout(cx,cy,inttostr(graff.adatok[a,b]));
     end;
  end;
end;
procedure TEdit.rp;
var i,j:integer;
begin
     with graff do
     for i:=1 to szogpontszam do begin
        for j:=1 to szogpontszam do begin
          doconnect(i,j);
        end;
     end;

end;

procedure Tedit.Button5Click(Sender: TObject);
begin
     modalresult:=mrcancel;
end;

procedure Tedit.Button3Click(Sender: TObject);
var c:integer;
begin
if sg.Checked then showmessage('Please select the start node!');
iss:=true;
while iss do application.ProcessMessages;
a1a:=a0a; spk[a0a].Brush.Color:=clMoneyGreen;
if sg.Checked then showmessage('Please select the end node!');
iss:=true;
while iss do application.ProcessMessages;
spk[a1a].Brush.Color:=clWhite; c:=1;
if graff.sulyozott then begin
  repeat
  elh.hossz.Text:='1';
  elh.hossz.SelectAll;
  elh.ShowModal;
  until strtointdef(elh.hossz.Text,-123)<>-123;
  c:=strtoint(elh.hossz.Text);
end;
graff.adatok[a1a,a0a]:=c;
if not graff.iranyitott then graff.adatok[a0a,a1a]:=c;
edit.Repaint;
end;

procedure Tedit.Button2Click(Sender: TObject);
var i,j:integer;
begin
if graff.szogpontszam=1 then exit;
if sg.Checked then showmessage('Please select the node to delete!');
iss:=true;
while iss do application.ProcessMessages;
spk[a0a].isdown:=false;
spk[spkn].Free;
dec(spkn);
edit.matr.RowCount:=edit.matr.RowCount-1;
edit.matr.ColCount:=edit.matr.ColCount-1;

with graff do begin
   dec(szogpontszam);
   for i:=1 to szogpontszam+1 do
       for j:=a0a to szogpontszam do
          adatok[i,j]:=adatok[i,j+1];
   for i:=1 to szogpontszam+1 do
       for j:=a0a to szogpontszam do
          adatok[j,i]:=adatok[j+1,i];
   for i:=a0a to szogpontszam do begin
      graff.koord[i,1]:=graff.koord[i+1,1];
      graff.koord[i,2]:=graff.koord[i+1,2];
   end;
   for i:=1 to szogpontszam do begin 
      spk[i].CX:=koord[i,1];
      spk[i].CY:=koord[i,2];
   end;
   for i:=1 to szogpontszam do
    for j:=1 to szogpontszam do
       edit.matr.Cells[i,j]:=inttostr(adatok[i,j]);
end;
edit.Repaint;
end;

procedure Tedit.Button6Click(Sender: TObject);
begin
if sg.Checked then    showmessage('Please select the start node!');
   iss:=true;
   while iss do application.ProcessMessages;
   a1a:=a0a; spk[a0a].Brush.Color:=clMoneyGreen;
if sg.Checked then    showmessage('Please select the end node!');
   iss:=true;
   while iss do application.ProcessMessages;
   spk[a1a].Brush.Color:=clWhite;
   if graff.adatok[a1a,a0a]=0 then showmessage('There is no such edge!!!');
   graff.adatok[a1a,a0a]:=0;
   graff.adatok[a0a,a1a]:=0;
   edit.Repaint;
end;

end.
