unit GrafGrid;

interface

uses
  SysUtils, Classes, Controls, Grids, ugraf;

type
  TGrafGrid = class(TStringGrid)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    down:boolean;
    mx,my:integer;
    procedure LoadFromGraf(var p:TGraf);

  published
    { Published declarations }
  end;

procedure Register;

implementation
procedure TGrafGrid.LoadFromGraf(var p:TGraf);
var i,j:integer;
begin
  if p.szogpontszam=0 then begin
     ColCount:=2;
     Rowcount:=2;
     FixedRows:=1;
     FixedCols:=1;
     cells[0,0]:='';
     cells[0,1]:='';
     cells[1,0]:='';
     cells[1,1]:='res';
  end else begin
    colcount:=p.szogpontszam+1;
    rowcount:=colcount;
    fixedrows:=1; fixedcols:=1;
    cells[0,0]:='';
    for i:=1 to p.szogpontszam do begin cells[0,i]:=inttostr(i); cells[i,0]:=inttostr(i) end
  end;
  for i:=1 to p.szogpontszam do
     for j:=1 to p.szogpontszam do
         begin
              cells[j,i]:=inttostr(p.adatok[i,j]);
         end;
  Options:=Options+[Gorowsizing,Gocolsizing];
  {26,22}
  Defaultcolwidth:=26;
  defaultrowheight:=22;
  for i:=0 to p.szogpontszam do begin RowHeights[i]:=22;
   colwidths[i]:=26
  end;
 
end;

procedure Register;
begin
  RegisterComponents('Standard', [TGrafGrid]);
end;

end.
